version = "1.7.0"

function stringsZH()
    enderrorString = "錯誤"
    warningString = "警告"
    settingsString = "設定"

    immersiveString = "浸潤模式(沒有海苔條請勾選)"
    saveFileNameString = "儲存錄製點擊到檔案: "
    recordDelayString = "錄製點擊時延遲秒數:\n(如果錄製時有時不會點擊請增加秒數)"

    fileExistsString = "檔案已存在，要覆蓋嗎?"
    overWriteOriginalString = "覆蓋原檔: "
    overWriteNewString = "覆蓋新檔: "
    storeNewString = "儲存到新檔: "

    stopLocationString = "停止錄製區域\n (按此紅色區域可停止錄製): \n"
    upperLeftString = "左上角"
    upperRightString = "右上角"
    lowerLeftString = "左下角"
    lowerRightString = "右下角"

    stopRecordString = "停止錄製"

    scriptToPlayString = "選擇要回放的檔案: "
    timesString = "回放次數: "
    gapString = "回放間隔幾秒: "
    contentString = "回放內容"

    modifiedString = "內容已更動"

    chooseActionString ="選擇要做的事"
    recordString = "錄製"
    playString = "回放"
    deleteString = "刪除錄製的檔案" --(將於下頁選擇要刪除那些檔案)"

    deleteDescriptionString = "請選擇要刪除的檔案"
    confirmDeleteString = "下列檔案將被刪除"
    noDeleteFileString = "沒有選取任何要刪除的檔案"

    notExistString =" 檔案不存在"
    fileCreateFailString = " 檔案創建失敗"

    cutoutString = "有瀏海且瀏海在上方\n(將偵測瀏海高度並做補償)"

    recordGuideTitle = "錄製注意事項"
    recordGuideString = "開始執行時，請務必等畫面罩上黃色再點擊畫面，否則無法錄製到點擊\n"
            .. "開始執行時，請務必等畫面罩上黃色再點擊畫面，否則無法錄製到點擊 \n"
            .. "開始執行時，請務必等畫面罩上黃色再點擊畫面，否則無法錄製到點擊\n\n"

    noLuarString = "在luar目錄下找不到已存在的.luar檔案，請先錄製腳本"
    noRemindString = "不再提醒"

end

function stringsZHCN()
    enderrorString = "错误"
    warningString = "警告"
    settingsString = "设定"

    immersiveString = "浸润模式(没有海苔条请勾选)"
    saveFileNameString = "储存录制点击到档案: "
    recordDelayString = "录制点击时延迟秒数:\n(如果录制时有时不会点击请增加秒数)"

    fileExistsString = "档案已存在，要覆盖吗?"
    overWriteOriginalString = "覆盖原档: "
    overWriteNewString = "覆盖新档: "
    storeNewString = "储存到新档: "

    stopLocationString = "停止录制区域\n (按此红色区域可停止录制): \n"
    upperLeftString = "左上角"
    upperRightString = "右上角"
    lowerLeftString = "左下角"
    lowerRightString = "右下角"

    stopRecordString = "停止录制"

    scriptToPlayString = "选择要回放的档案: "
    timesString = "回放次数: "
    gapString = "回放间隔几秒: "
    contentString = "回放内容"

    modifiedString = "内容已更动"

    chooseActionString ="选择要做的事"
    recordString = "录制"
    playString = "回放"
    deleteString = "删除录制的档案" --(将于下页选择要删除那些档案)"

    deleteDescriptionString = "请选择要删除的档案"
    confirmDeleteString = "下列档案将被删除"
    noDeleteFileString = "没有选取任何要删除的档案"

    notExistString =" 档案不存在"
    fileCreateFailString = " 档案创建失败"

    cutoutString = "有浏海且浏海在上方\n(将侦测浏海高度并做补偿)"

    recordGuideTitle = "录制注意事项"
    recordGuideString = "开始执行时，请务必等画面罩上黄色再点击画面，否则无法录制到点击\n"
            .. "开始执行时，请务必等画面罩上黄色再点击画面，否则无法录制到点击 \n"
            .. "开始执行时，请务必等画面罩上黄色再点击画面，否则无法录制到点击\n\n"

    noLuarString = "在luar目录下找不到已存在的.luar档案，请先录制脚本"
    noRemindString = "不再提醒"

end

function stringsEN()
    errorString = "Error"
    warningString = "Warning"
    settingsString = "Settings"

    immersiveString = "Immersive mode"
    saveFileNameString = "Save recording to file: "
    recordDelayString = "Seconds to delay when recording click:\n(Increase the value if failing to click sometimes)"

    fileExistsString = "File exists. Overwrite?"
    overWriteOriginalString = "Overwrite original file: "
    overWriteNewString = "Overwrite new file: "
    storeNewString = "Store to new file: "

    stopLocationString = "Stop recording area\n (click the red area to stop): \n"
    upperLeftString = "Upper left"
    upperRightString = "Upper right"
    lowerLeftString = "Lower left"
    lowerRightString = "Lower Right"

    stopRecordString = "Stop recoring"

    scriptToPlayString = "The file to playbak: "
    timesString = "Replay times: "
    gapString = "Gap (second) between replay: "
    contentString = "Plackback Content"

    modifiedString = "Content modified"

    chooseActionString ="Choose what to do"
    recordString = "Record"
    playString = "Playback"
    deleteString = "Delete recorded files" --. \n(Select which file(s) to delete in next page)"

    deleteDescriptionString = "Select files to delete"
    confirmDeleteString = "Following files will be deleted"
    noDeleteFileString = "No file selected to delete"

    notExistString =" file doesn't exist."
    fileCreateFailString = " file creation fails."

    cutoutString = "with cutout and cutout on device top \n(Will detect cutout height and compensate)"

    recordGuideTitle = "Recording Notes"
    recordGuideString = "When running, please only touch the screen when there is light yellow on screen. Or the touch will not be recorded.\n"
            .. "When running, please only touch the screen when there is light yellow on screen. Or the touch will not be recorded.\n"
            .. "When running, please only touch the screen when there is light yellow on screen. Or the touch will not be recorded.\n\n"

    noLuarString = "Can't find .luar file under luar directory. Please record first."

    noRemindString = "Don't remind again"

end

function cutoutHeightMeasure(startY)
    local width = getRealScreenSize():getX()
    local height = getRealScreenSize():getY()

    local testHeight = math.floor(height / 8)
    setHighlightStyle(0xff567890, true)
    local reg = Region(0, startY, width / 4, testHeight)
    reg:highlight()
    wait(0.5)
    snapshotColor()
    reg:highlightOff()
    local maxY = 0
    local found = false
    for y = math.floor(testHeight/2) + startY, startY + testHeight * 2 do
        local r, g, b = getColor(Location(10, y))
        --        print (string.format("y = %d, r = %x, g = %x, b = %x", y, r, g, b))
        if (found and (r ~= 0x56 or g ~= 0x78 or b ~= 0x90)) then
            maxY = y - 1
            break
        end
        if (r == 0x56 and g == 0x78 and b == 0x90) then
            found = true
        end
    end

    usePreviousSnap(false)
    setHighlightStyle(0xffff0000, false)
    local cHeight = maxY - testHeight - startY
    if (cHeight < 10) then cHeight = 0 end
    return (cHeight)
end

function loadStringsFunction()
    local language = getLanguage()
    if (language == "zh") then
        if (getCountry() == "CN") then
            stringsZHCN()
        else
            stringsZH()
        end
    else
        stringsEN()
    end
end

function fileExists(name)
    local fName = localPath .. "luar/" .. name .. ".luar"
    local f=io.open(fName,"r")
    if f~=nil then io.close(f) return true else return false end
end

function fileCheck(name, text)
    overwrite = 0
    removePreference("overwriteFileName")
    local fName = string.gsub(name, ".luar$", "")
    name = fName
    fileName = preferenceGetString("fileName", "")

    while (overwrite == 0 and fileExists(fName)) do
        dialogInit()
        addTextView(text)
        newRow()
        addRadioGroup("overwrite", 0)
        addRadioButton(overWriteOriginalString .. name .. ".luar", 1)
        if (fName ~= "") then
            addRadioButton(overWriteNewString .. fileName .. ".luar", 2)
        end

        addRadioButton(storeNewString, 0)
        newRow()
        addEditText("fileName", "touch2")
        addTextView(".luar")
        dialogShowFullScreen(text)

        if (overwrite == 1) then
            fName = name
        else
            fName = fileName
        end
    end
    return localPath .. "luar/" .. fName .. ".luar"
end

function locationInRegion(loc, reg)
    local l = loc
    local x = l:getX()
    local y = l:getY()
    return (x > reg:getX() and x < (reg:getX() + reg:getW()) and
            y > reg:getY() and y < (reg:getY() + reg:getH()))
end

function locationToString(loc)
    return(string.format("Location(%d, %d)", loc:getX(), loc:getY()))
end

function fileHeader(fPointer)
    fPointer:write("----- created by AnkuLua record script ------\n")
    fPointer:write("immersive = " .. tostring(immersive) .. "\n")
    fPointer:write("setImmersiveMode(immersive)\n")
    if (genVersion) then
        fPointer:write('genVersion = "' .. genVersion .. '"\n')
    end
    if (setAutoGameArea) then
        fPointer:write("setAutoGameArea = " .. tostring(setAutoGameArea) .. "\n")
        fPointer:write("pcall (autoGameArea, setAutoGameArea)\n")
    end
    fPointer:write("scriptDimension = " .. scriptDimension .. "\n")
    fPointer:write("Settings:setScriptDimension(true, scriptDimension)\n")
    fPointer:write("local index = 1\n")
    fPointer:write("touchList = {}\n")
    fPointer:write("waitList = {}\n")
    fPointer:write("\n")
end

function record()
    if (false) then
        setAutoGameArea = true
        autoGameArea(true)
    else
        setAutoGameArea = false
    end
    genVersion = getVersion()

    dialogInit()
    --addCheckBox("immersive", immersiveString, false)
    --newRow()
    --newRow()
    immersive = true

    addTextView(saveFileNameString)
    newRow()
    addEditText("fileName", "touch1")
    addTextView(".luar")
    newRow()
    addTextView("    ")
    newRow()
    addTextView(recordDelayString)
    newRow()
    addTextView("    ")
    local delayItems = {"0.0", "0.1", "0.2", "0.3", "0.4", "0.5"}
    addSpinnerIndex("recordDelay", delayItems, 3)
    newRow()
    newRow()
    addTextView(stopLocationString)
    local areaItems = {upperLeftString, upperRightString, lowerLeftString, lowerRightString }
    addSpinnerIndex("stopIndex", areaItems, areaItems[3])
    newRow()
    newRow()
    addSeparator()
    addCheckBox("recordDebug", "Debug", true)
    dialogShowFullScreen(settingsString)

    recordDelay = (recordDelay - 1) / 10

    setImmersiveMode(immersive)
    if (false) then
        autoGameArea(true)
        scriptDimension = getGameArea():getW()
    else
        if (immersive) then
            scriptDimension = getRealScreenSize():getX()
        else
            scriptDimension = getAppUsableScreenSize():getX()
        end
    end
    Settings:setScriptDimension(true, scriptDimension)

    os.execute("mkdir " .. localPath .. "luar")

    fileName = string.gsub(fileName, "%s", "_")
    fileName = fileCheck(fileName, fileExistsString)

    local width, height
    if (immersive) then
        width = getRealScreenSize():getX()
        height = getRealScreenSize():getY()
    else
        width = getAppUsableScreenSize():getX()
        height = getAppUsableScreenSize():getY()
    end
    local stopWidth = width / 8
    local stopHeight = height / 8
    if (stopIndex == 1) then
        stopArea = Region(0, 0, stopWidth, stopHeight)
    elseif (stopIndex == 2) then
        stopArea = Region(width - stopWidth, 0, stopWidth, stopHeight)
    elseif (stopIndex == 3) then
        stopArea = Region(0, height - stopHeight, stopWidth, stopHeight)
    else
        stopArea = Region(width - stopWidth, height - stopHeight, stopWidth, stopHeight)
    end
    setHighlightStyle(0x80ff0000, true)
    setHighlightTextStyle(0x80ff0000, 0x80ffffff, 16)
    stopArea:highlight("Stop!")
    wait(0.2)
    for i = 1, 2 do
        local shownRegion = stopArea:getRegionOnScreen()
        if(shownRegion:getX() >= 0 and shownRegion:getY() >= 0) then
            stopArea = shownRegion
            break
        end
    end

    local fPointer = io.open(fileName, "w")
    if (not fileName) then
        scriptExit(fileName .. fileCreateFailString)
    end
    fileHeader(fPointer)

    local noRecordRemind = preferenceGetBoolean("noRecordRemind", false)
    if (not noRecordRemind) then
        dialogInit()
        addTextView(recordGuideString)
        newRow()
        newRow()
        addCheckBox("noRecordRemind", noRemindString, false)
        dialogShowFullScreen(recordGuideTitle)
    end


    local timer = Timer()
    local waitTime, text
    local index = 0
    while(true) do
        local action, locTable, touchTable = getTouchEvent()
        wait(recordDelay)
        if (index ~= 0) then
            fPointer:write("------ " .. index .. " -----\n")
            fPointer:write(text .. "\n")
            print(index .. ": " .. text)
            waitTime = timer:check()
            fPointer:write(string.format("waitList[index] = %f\n", waitTime))
            fPointer:write("index = index + 1\n\n")
        end

        if (action == "click" or action == "longClick") then
            locTable = locTable:offset(0, cutoutHeightEvent)
            if (locationInRegion(locTable, stopArea)) then
                io.close(fPointer)
                scriptExit(stopRecordString)
            end
            if (action == "longClick") then
                longClick(locTable, 1.5)
            else
                _G[action](locTable)
            end
            highlightLoc = locTable
            text = string.format('touchList[index] = {"%s", %s}', action, locationToString(locTable))
        end

        if (action == "swipe" or action == "dragDrop") then
            locTable[1] = locTable[1]:offset(0, cutoutHeightEvent)
            locTable[2] = locTable[2]:offset(0, cutoutHeightEvent)
            _G[action](locTable[1], locTable[2])
            highlightLoc = locTable[1]
            text = string.format('touchList[index] = {"%s", %s, %s}', action,
                    locationToString(locTable[1]), locationToString(locTable[2]))
        end

        --Region(highlightLoc:getX()-2, highlightLoc:getY()-2, 5, 5):highlight(0.5)
        timer:set()
        index = index + 1
        if (recordDebug)  then toast(index .. ": " .. text) end

    end

end

------------------ playback related functions -------------------

function scandir(directory)

    local command = "ls " .. directory .. " > /sdcard/__list"
    os.execute(command)

    local lines = {}
    local i = 1
    for line in io.lines("/sdcard/__list") do
        lines[#lines + 1] = line
    end

    return lines
end


function playback()

    local fileList = scandir(luarPath ..  "*.luar")
    if (#fileList == 0) then
        scriptExit(noLuarString)
    end

    dialogInit()
    addTextView(timesString)
    addEditNumber("times", 5)
    newRow()

    addTextView(gapString)
    addEditNumber("gap", 0.5)
    newRow()

    addTextView(scriptToPlayString)
    newRow()
    addRadioGroup("fileNum", 1)
    for i, f in ipairs(fileList) do
        local subString = localPath .. "luar/"
        local shortName = string.gsub(f, luarPath, "")
        addRadioButton(shortName, i)
        fileList[i] = shortName
    end
    newRow()
    dialogShowFullScreen(settingsString)

    fileName = fileList[fileNum]
    dofile (luarPath .. fileName)

    local totalAction = {"click", "longClick", "doubleClick", "continueClick", "swipe", "dragDrop" }
    local singleAction = {"click", "longClick", "doubleClick", "continueClick"}
    local twoAction = {"swipe", "dragDrop" }
    local screenSize = getRealScreenSize()
    local screenWidth = screenSize:getX()
    local portrait = screenWidth < screenSize:getY()

    dialogInit()
    for i, t in ipairs(touchList) do
        addTextView("    "..i..": ")
        local enableCheck = "enable" .. i
        removePreference(enableCheck)
        addCheckBox(enableCheck, " ", true)
        local actionVar = "action" .. i

        local actionFound = false
        for i, a in ipairs(totalAction) do
            local match = string.match(t[1], a)
            if (match) then t[1] = match; actionFound = true; break end
            --            if (a == action) then actionFound = true; break end
        end
        if (not actionFound) then scriptExit("touchList[" .. i .. "]: " .. touchList[i][1] .. " not supported") end

        local action = t[1]


        removePreference(actionVar)
        if (action == "swipe" or action == "dragDrop") then
            addSpinner(actionVar, totalAction, t[1])
        else
            addSpinner(actionVar, singleAction, t[1])
        end
        addTextView(t[2]:toString())
        if (action == "swipe" or action == "dragDrop") then
            addTextView("->" .. t[3]:toString())
        end
        if (screenWidth < 1000 or portrait) then
            newRow()
            addTextView("        ")
        end
        addTextView(" wait: ")
        local waitVar = "wait" .. i
        removePreference(waitVar)
        local waitTime
        if (not waitList[i]) then waitList[i] = 0.0 end
        addEditNumber(waitVar, waitList[i])

        newRow()

    end
    dialogShowFullScreen(contentString)

    local modified = false
    for i, t in ipairs(touchList) do
        local actionVar = "action" .. i
        local waitVar = "wait" .. i
        local enableCheck = "enable" .. i
        if (not _G[enableCheck] or _G[actionVar] ~= t[1] or _G[waitVar] ~= waitList[i]) then
            modified = true
            break
        end
        t[1] = _G[actionVar]
        waitList[i] = _G[waitVar]
    end

    local newTouchList = {}
    if (modified) then
        local touchNum = #touchList
        local header = ""
        local orgFPointer = io.open(luarPath .. fileName, "r")
        for line in orgFPointer:lines() do
            header = header .. line .. "\n"
            if string.find(line, "waitList = {}") then
                header = header .. "\n"
                break
            end
        end
        io.close(orgFPointer)

        local newFile = fileCheck(fileName, modifiedString)
        --print("newFile = " .. newFile)
        local fPointer = io.open(newFile, "w")
        --fileHeader(fPointer)
        fPointer:write(header)

        local index = 1
        for i, t in ipairs(touchList) do
            local enableCheck = "enable" .. i

            if (_G[enableCheck]) then
                local action = _G["action" .. i]
                local text
                local waitTime = _G["wait" .. i]

                fPointer:write("------ " .. index .. " -----\n")
                if (action == "swipe" or action == "dragDrop") then
                    text = string.format('touchList[index] = {"%s", %s, %s}\n', action,
                            locationToString(t[2]), locationToString(t[3]))
                    fPointer:write(text)
                    newTouchList[index] = {action, t[2], t[3]}
                else
                    text = string.format('touchList[index] = {"%s", %s}\n', action, locationToString(t[2]))
                    fPointer:write(text)
                    newTouchList[index] = {action, t[2]}
                end
                fPointer:write(string.format("waitList[index] = %f\n", waitTime))
                waitList[index] = waitTime
                index = index + 1

                fPointer:write("index = index + 1\n\n")
            end
        end
        io.close(fPointer)
    end

    if (modified) then
        touchList = newTouchList
    end

    local timer = Timer()
    for i = 1, times do
        for j, t in ipairs(touchList) do

            if (t[1] == "swipe" or t[1] == "dragDrop") then
                _G[t[1]](t[2], t[3])
            elseif (t[1] == "continueClick") then
                continueClick(t[2], 100)
            elseif (t[1] == "longClick") then
                longClick(t[2], 1.5)
            else
                _G[t[1]](t[2])
            end
            if (i ~= times or j ~= #touchList) then
                wait(waitList[j])
            end
            --            end
        end
        if (i ~= times) then
            wait(gap)
        end
    end

end

function delete()
    local fileList = scandir(luarPath ..  "*.luar")
    if (#fileList == 0) then
        scriptExit(noLuarString)
    end

    dialogInit()
    addTextView(deleteDescriptionString)
    newRow()
    for i, f in ipairs(fileList) do
        local shortName = string.gsub(f, luarPath, "")
        removePreference("file" .. i)
        addCheckBox("file" .. i, shortName, false)
        newRow()
        fileList[i] = shortName
    end
    newRow()
    dialogShowFullScreen(deleteDescriptionString)

    local fileSelected = false
    for i = 1, #fileList do
        if (_G["file" .. i]) then
            fileSelected = true
            break
        end
    end

    if (not fileSelected) then
        toast(noDeleteFileString)
        return
    end

    dialogInit()
    addTextView(confirmDeleteString)
    newRow()
    newRow()
    for i = 1, #fileList do
        if (_G["file" .. i]) then
            addTextView(fileList[i])
            newRow()
        end
    end
    newRow()
    dialogShowFullScreen(confirmDeleteString)

    for i = 1, #fileList do
        if (_G["file" .. i]) then
            local fullPath = luarPath .. fileList[i]
            if(not os.remove(fullPath)) then
                print("Fail to remove " ..fullPath)
            end
        end
    end

end

localPath = scriptPath()
luarPath = localPath .. "luar/"
loadStringsFunction()

print ("Version: " .. version)

local width = getRealScreenSize():getX()
local height = getRealScreenSize():getY()
cutoutHeight = 0
detectCutout = false
repeat
    dialogInit()
    detectCutout = false

    addTextView(chooseActionString)
    newRow()
    addRadioGroup("actionSelect", 1)
    addRadioButton(recordString, 1)
    addRadioButton(playString, 2)
    addRadioButton(deleteString, 3)
    dialogShowFullScreen(settingsString)

    cutoutHeightEvent = 0
    if (detectCutout) then
        cutoutHeightEvent = cutoutHeightMeasure(0)
        print("cutout height = " .. cutoutHeightEvent)
        cutoutHeight = cutoutHeightMeasure(cutoutHeightEvent * 2)
        print("cutut highlight offset = " .. cutoutHeight)

    end


    if (actionSelect == 1) then
        record()
    elseif (actionSelect == 2) then
        playback()
    else
        delete()
    end

until (actionSelect ~= 3)